/***
        file     : sequence.c
        function : work with char *seq
                                                 
        created  : 20 Dec 2002
        modif    : 

        author   : amikezor
***/

#include <stdio.h>
#include <string.h>


/* -------------------------------------------- */
/* verifie les caracteres d'une sequence	*/
/* -------------------------------------------- */
short CheckSeq(char *seq, char *alpha)
{
	int ntot, nbad;
	
	/*fprintf(stderr, "Verifying sequence ... ");*/

	for ( ntot = nbad = 0; *seq ; seq++, ntot++)
		if (! strchr(alpha, *seq))
			nbad++;

	if (nbad){
		fprintf(stderr, "*WARNING* %d bad symbols on %d total ... ", nbad, ntot);
		return 0;
	}
	     
	return 1;
}

/* -------------------------------------------- */
/*   change all non A,C,G,T,X char into N       */
/* -------------------------------------------- */
void nonACGTXtoN(char *seq)
{
	char *pseq;
	
	for( pseq=seq; *pseq; pseq++ )
		if (! strchr("ACGTX", *seq) )
			*seq='N';

		 
	return;
}

/* -------------------------------------------- */
/*          uppercase sequence				      */
/* -------------------------------------------- */

#define IS_LOWER(c) (((c) >= 'a') && ((c) <= 'z'))
#define TO_UPPER(c) ((c) - 'a' + 'A')

void UpperSequence(char *seq){

    char *cseq;

	for (cseq = seq ; *cseq ; cseq++) 
		if (IS_LOWER(*cseq))
			*cseq = TO_UPPER(*cseq);
		 
}
 
#undef IS_LOWER
#undef TO_UPPER

