/******
        file     : matrix.c
        function : set up matrix for alignment
                                                 
        created  : 26 Nov 2002
        modif    : 

        author   : amikezor
*****/
#include "SharMot.h"


/*
	Set all value to +4 or -4
	Set all N to +1
	Set all X to -100,000
*/
void identity_matrix(SCORING *pScoring, int gap_open, int gap_ext){

	int i,u;
	
	for(i=0;i<MATRIX_SIZE;i++)
		for(u=0;u<MATRIX_SIZE;u++)
			pScoring->matrix[i][u]=(u==i)?4:-4;

	for(i=0;i<MATRIX_SIZE;i++){
		pScoring->matrix[CHAR2SYMB('N')][i] = pScoring->matrix[i][CHAR2SYMB('N')] = 1;
	}

	 pScoring->gap_open = (gap_open<0)? gap_open*4 : -gap_open*4;
	 pScoring->gap_ext  = (gap_ext<0 )?  gap_ext*4 : -gap_ext*4;

	for(i=0;i<MATRIX_SIZE;i++)              /* set all X against anything to -1000 */
			pScoring->matrix[i][CHAR2SYMB('X')] = pScoring->matrix[CHAR2SYMB('X')][i] = -100000; 

}
