/******
        file     : mem.c
        function : get memoy for all alignemnt procedure
                                                 
        created  : 26 Nov 2002
        modif    : 

        author   : amikezor
*****/

#include "SharMot.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>



/*
	All you need for recursive alignment
*/
void memset_RecursivAlign(RESULTS *pResults, char *seq1, char *seq2){

	size_t size1, size2;
	
	size1 = strlen(seq1)+1;
	size2 = strlen(seq2)+1;

	memset(pResults->scores, 0, size1*size2*sizeof(int));
	memset(pResults->traces, 0, size1*size2*sizeof(char));
	memset(pResults->F, 0, size1*size2*sizeof(int));
	memset(pResults->E, 0, size1*size2*sizeof(int));
	

}

void mem_RecursivAlign(RESULTS *pResults, char *seq1, char *seq2){

	size_t size1, size2;
	
	size1 = strlen(seq1)+1;
	size2 = strlen(seq2)+1;

	pResults->scores = (int *) calloc( size1*size2, sizeof(int) );
	pResults->traces = (char *) calloc( size1*size2, sizeof(char) );
	pResults->F = (int *) calloc( 10*size1*size2, sizeof(int) );
	pResults->E = (int *) calloc( 10*size1*size2, sizeof(int) );

	pResults->traceback = (char *)calloc(size1+size2, sizeof(char));
	
	if(!pResults->scores || !pResults->traces || !pResults->traceback || !pResults->F)
		fprintf(stderr," init_results: malloc error\n"),exit(3);
		
	pResults->size_row = (int)size1;
	pResults->size_col = (int)size2;
	
	pResults->BestScore=0;        /* best score and its position in matrix */
	pResults->BestScore_row=0;
	pResults->BestScore_col=0;

}

void free_RecursivAlign(RESULTS *pResults){

	free(pResults->traceback);
	free(pResults->scores);
	free(pResults->traces);
	free(pResults->F);
	free(pResults->E);
	
}
