/******
        file     : tableR.c
        function : get the redondancy along the sequences
                                                 
        created  : 6 march 2003
        modif    : 11 march 2003 - correct bugs in Update_tableR()
		  note     : similar to family.c - nosferatu - 24/25 Oct 2002
        author   : amikezor
*****/

#include "SharMot.h"
#include <stdlib.h>
#include <stdio.h>

void mem_tableR(int size_seq1, int size_seq2, int **ptableR1, int **ptableR2)
{

	*ptableR1 = calloc(size_seq1+1, sizeof(int));
	*ptableR2 = calloc(size_seq2+1, sizeof(int));
	if(!*ptableR1 || !*ptableR2)fprintf(stderr, "mem_tableR: calloc failed, bye\n"),exit(3);

}

void free_tableR(int *tableR1, int *tableR2){
	free(tableR1);
	free(tableR2);
}

void Update_tableR(int *tableR1, int *tableR2, int Pos1, int Len1, int Pos2, int Len2 )
{
	tableR1[ Pos1 ]+=1;
	tableR1[ Pos1 + Len1 ]-=1;

	tableR2[ Pos2 ]+=1;
	tableR2[ Pos2 + Len2 ]-=1;
}

void Finish_tableR(int size_seq1, int size_seq2, int *tableR1, int *tableR2)
{
	int count=0;
	int i=0;
	
	for(count=0, i=0; i<size_seq1 ; i++)
      tableR1[i] = (count+=tableR1[i]);   
		
	for(count=0, i=0; i<size_seq2 ; i++)
      tableR2[i] = (count+=tableR2[i]);   

}
